//\/////
//\  coolTip Animation Plugin
//\  This file requires coolTip 2.00 or later.
//\  Created on July 12, 2013; Modified July 27, 2013, July 29, 2013, August 10, 2013
//\   Code rewritten on November 18, 2018
//\   Corrected an error pointed out by Peter Hofer with regard to animation
//\
//\  You may not remove or change this notice.
//\  Copyright Robert E Boughner 2005. All rights reserved.
//\  
//\  This plugin is governed by the same restrictions set forth
//\  in the prologue to cCore.js. Modified Nov. 25, 2013 to add 
//\  the rolly, rollx effects.  Modified Nov. 27, 2013 changed 
//\  timing-function for rolly and rollx to be the same as for
//\  the X-slide effects.
//\
//\  This plugin implements animation effects using CSS3.
//\
//\  Animations include:
//\	 1. zoom
//\	 2. tumble
//\	 3. pivot
//\	 4. wink
//\	 5. flip
//\	 6. rolly
//\ 	 7. rollx
//\	 8. top-slide
//\	 9. bottom-slide
//\	10. left-slide
//\	11. right-slide
//\	12. wobble
//\	13. wiggle
//\
//\  The duration of each is set to the default value of '500ms' with a delay of '0s'.
//\  A valid time specification is a number (integer or floating point) followed by a time length unit (s, ms)
//\/////
function isTime(v,type){return(typeof v===type&&v.lastIndexOf('s')>-1);}
if(!cInfo.meets(2.0))alert('coolTip 2.0 or later is required for the Animation Plugin.');else{cLoaded=0;var cAnimEffects=[];registerCommands('animation,animduration,animdelay');setDefaultVariables('animation||animduration|0.5s|animdelay|0s');
function cSetCombinedStyles(arg){  /* arg is a combined animation,separated with-*/
var i,k,tCls,sh='',tTrnsfrm=[],theAnimations,prefixes=['','-webkit-'];if(arg){tCls=arg;theAnimations=arg.split('-');for(i=0;i<prefixes.length;i++){sh+='@'+prefixes[i]+'keyframes '+tCls+' {\n';tTrnsfrm[0]=tTrnsfrm[1]='transform: ';tTrnsfrm[2]='';for(k=0;k<theAnimations.length;k++){switch(theAnimations[k]){case 'flip':
tTrnsfrm[2]='transform-origin: 50% 0%;';break;case 'zoom':
tTrnsfrm[2]='transform-origin: 100% 100%;';break;}
tTrnsfrm[0]+=cAnimEffects[theAnimations[k]].start+' ';tTrnsfrm[1]+=(tTrnsfrm[1].indexOf(cAnimEffects[theAnimations[k]].end)==-1)?cAnimEffects[theAnimations[k]].end+' ':' ';tTrnsfrm[0]=tTrnsfrm[0].replace(/\s*$/,' ');tTrnsfrm[1]=tTrnsfrm[1].replace(/\s*$/,' ');}
sh+='     0% { '+(tTrnsfrm[2]?prefixes[i]+tTrnsfrm[2]:'')+prefixes[i]+tTrnsfrm[0]+'}\n';sh+='   100% { '+prefixes[i]+tTrnsfrm[1]+'}\n';sh+='}\n'}}
return sh;}
function cSetAnimationStyles(arg){  /* arg is an input array of multiple animatios */
var i,k,sh='',tTrnsfrm=[],theAnimations,prefixes=['','-webkit-'];if(arg){theAnimations=arg;for(k=0;k<theAnimations.length;k++){for(i=0;i<prefixes.length;i++){sh+='@'+prefixes[i]+'keyframes '+theAnimations[k]+' {\n';tTrnsfrm[0]=tTrnsfrm[1]='transform: ';tTrnsfrm[2]='';switch(theAnimations[k]){case 'flip':
tTrnsfrm[2]='transform-origin: 50% 0%;';break;case 'zoom':
tTrnsfrm[2]='transform-origin: 100% 100%;';break;}
tTrnsfrm[0]+=cAnimEffects[theAnimations[k]].start+' ';tTrnsfrm[1]+=(tTrnsfrm[1].indexOf(cAnimEffects[theAnimations[k]].end)==-1)?cAnimEffects[theAnimations[k]].end+' ':' ';tTrnsfrm[0]=tTrnsfrm[0].replace(/\s*$/,' ');tTrnsfrm[1]=tTrnsfrm[1].replace(/\s*$/,' ');sh+='     0% { '+(tTrnsfrm[2]?prefixes[i]+tTrnsfrm[2]:'')+prefixes[i]+tTrnsfrm[0]+'}\n';sh+='   100% { '+prefixes[i]+tTrnsfrm[1]+'}\n';sh+='}\n'}}}
return sh;}
function cSetAnimationTransforms(){var j,allowed='zoom,tumble,pivot,wink,flip,rolly,rollx,top-slide,bottom-slide,left-slide,right-slide,wiggle,wobble';var cAllowed=allowed.split(',');for(j=0;j<cAllowed.length;j++){switch(cAllowed[j]){case 'zoom':
cAnimEffects[cAllowed[j]]={start: 'scale(0.2)',end: 'scale(1)'};break;case 'tumble':
cAnimEffects[cAllowed[j]]={start: 'rotate(-120deg)',end: 'rotate(0deg)'};break;case 'pivot':
cAnimEffects[cAllowed[j]]={start: 'scale(0,1)',end: 'scale(1,1)'};break;case 'wink':
cAnimEffects[cAllowed[j]]={start: 'scale(1,0)',end: 'scale(1,1)'};break;case 'flip':
cAnimEffects[cAllowed[j]]={start: 'rotate(-180deg)',end: 'rotate(0deg)'};break;case 'rolly':
cAnimEffects[cAllowed[j]]={start: 'rotateY(-180deg)',end: 'rotateY(0deg)'};break;case 'rollx':
cAnimEffects[cAllowed[j]]={start: 'rotateX(-180deg)',end: 'rotateX(0deg)'};break;case 'top-slide':
cAnimEffects[cAllowed[j]]={start: 'translateY(-2000px)',end: 'translateY(0)'};break;case 'bottom-slide':
cAnimEffects[cAllowed[j]]={start: 'translateY(2000px)',end: 'translateY(0)'};break;case 'left-slide':
cAnimEffects[cAllowed[j]]={start: 'translateX(-2000px)',end: 'translateX(0)'};break;case 'right-slide':
cAnimEffects[cAllowed[j]]={start: 'translateX(2000px)',end: 'translateX(0)'};break;case 'wiggle':
cAnimEffects[cAllowed[j]]={start: 'skew(-20deg)',end: 'skew(0deg)'};break;case 'wobble':
cAnimEffects[cAllowed[j]]={start: 'rotate(-5deg)',end: 'rotate(0deg)'};break;}}
cSetAnimateCss(cAllowed);function cSetAnimateCss(allAnimations){var i,tBegChrs,sh='',tAnim='',prefixes=['','-webkit-'];tAnim+='.rB-animate {\n';for(i=0;i<prefixes.length;i++){tBegChrs=(prefixes[i].charAt(0)==''?'   ':'  ');tAnim+=tBegChrs+prefixes[i]+'animation-fill-mode: both;\n';tAnim+=tBegChrs+prefixes[i]+'animation-timing-function: linear;\n';}
tAnim+='}\n';sh+=cSetAnimationStyles(allAnimations);sh=tAnim+sh;cAddSheet(sh);}}
function setAnimationVariables(obj){obj.animation=cd_animation;obj.animduration=cd_animduration;obj.animdelay=cd_animdelay;}
function parseAnimationExtras(cObj,i,ar){var k=i,v,po,cD=true;if(cObj!=null){cD=false;po=cObj.pop;}
if(k<ar.length){if(ar[k]==ANIMATION){v=ar[(++k)];(cD?cd_animation=v:po.animation=v);return k;}
if(ar[k]==ANIMDURATION){v=ar[(++k)];if(isTime(v,'string'))(cD? cd_animduration=v:po.animduration=v);return k;}
if(ar[k]==ANIMDELAY){v=ar[(++k)];if(isTime(v,'string'))(cD?cd_animdelay=v:po.animdelay=v);return k;}}
return-1;}
function cAddSheet(sh){var h,hd;h=document.createElement('style');h.type='text/css';h.appendChild(document.createTextNode(sh));hd=document.getElementsByTagName('head');hd[0].appendChild(h);}
function cRmvStyles(obj){var p0,i,tCls,re2,tParent,tHead,tStyles;if(obj){p0=obj.pop;if(p0.animation){tCls=p0.animation.split(',').join('-');obj.classList.remove('rB-animate',tCls);re2="\\.rB-animate\\."+tCls.replace(/-/g,"\\-");re2=RegExp(re2);tParent=document.body.parentNode;tHead=tParent.getElementsByTagName("head")[0];tStyles=tHead.getElementsByTagName("style");if(tStyles){for(i=0;i<tStyles.length;i++){if(!re2.test(tStyles[i].innerHTML))continue;tStyles[i].outerHTML='';break;}}}}}
function isValidAnimation(animations){var allowed='zoom,tumble,pivot,wink,flip,rolly,rollx,top-slide,bottom-slide,left-slide,right-slide,wiggle,wobble';var retVal=false,re1,tSupVal=0,k,m,tSupAnim;if(animations){re1=allowed.split(',').join('|');re1=re1.replace(/\-/g,"\\-");re1=RegExp(re1);tSupAnim=animations.split(',');for(k=0;k<tSupAnim.length;k++){if(re1.test(tSupAnim[k]))tSupVal++;}
retVal=(tSupVal==tSupAnim.length);}
return retVal;}
function cSetClass(obj){var i,k,p0,tCls,Animations,tBegChrs,tName='',tDur='',prefixes=['','-webkit-'];var tRedTm,sh;if(obj){p0=obj.pop;if(isValidAnimation(p0.animation)){if(p0.animduration&&!isTime(p0.animduration,'string'))p0.animduration='0.5s';if(p0.animdelay&&!isTime(p0.animdelay,'string'))p0.animdelay='0s';Animations=p0.animation.split(',');tCls=Animations.join('-');if(Animations.length>1)sh=cSetCombinedStyles(tCls);tName+='.'+tCls+' {\n';tDur+='.rB-animate.'+tCls+' {\n';for(i=0;i<prefixes.length;i++){tBegChrs=(prefixes[i].charAt(0)==''?'   ':'  ');tName+=tBegChrs+prefixes[i]+'animation-name: '+tCls+';\n';if(!/wiggle|wobble/.test(tCls)){tDur+=tBegChrs+prefixes[i]+'animation-duration: '+p0.animduration+';\n';}
tDur+=tBegChrs+prefixes[i]+'animation-delay: '+p0.animdelay+';\n';switch(tCls){case 'rolly':
case 'rollx':
case 'top-slide':
case 'bottom-slide':
case 'left-slide':
case 'right-slide':
tDur+=tBegChrs+prefixes[i]+'animation-timing-function: cubic-bezier(0.5,0.2,0.5,0.8);';break;case 'wiggle':
case 'wobble':
tRedTm=String(Math.ceil(10000*parseFloat(p0.animduration)/3)/10000);tDur+=tBegChrs+prefixes[i]+'animation-duration: '+tRedTm+'s;\n';tDur+=tBegChrs+prefixes[i]+'animation-iteration-count: 3;\n';tDur+=tBegChrs+prefixes[i]+'animation-direction: alternate;\n';break;}}
tDur+='}\n';tName+='}\n';sh=(sh?tName+tDur+sh:tName+tDur);cAddSheet(sh);obj.classList.add('rB-animate',tCls);}}}
registerRunTimeFunction(setAnimationVariables);registerCmdLineFunction(parseAnimationExtras);registerHook("showObject",cSetClass,FBEFORE);registerHook("hideObject",cRmvStyles,FAFTER);cSetAnimationTransforms();cLoaded=1;}
